__UNICODE__ EQU 1
include masm32rt.inc
include \masm32\macros\macro_ex.asm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

WND_DATA struct
	hdc			HDC 	?
	hBmp		HBITMAP	?
WND_DATA ends

.code
main proc 
LOCAL wcex:WNDCLASSEXW
LOCAL msg:MSG

	mov wcex.hInstance,rv(GetModuleHandle,0)
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,uc$("Win32GDI+,SmplMath")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	fnx RegisterClassEx,&wcex
	fnx esi = CreateWindowEx,0,wcex.lpszClassName,"win32",WS_VISIBLE or WS_SYSMENU,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,wcex.hInstance,0
	fnx ShowWindow,esi,SW_SHOWNORMAL
	fnx UpdateWindow,esi

	.while 1
		fnx GetMessage,&msg,NULL,0,0
		.break .if !eax || eax == -1
		fnx TranslateMessage, &msg
		fnx DispatchMessage, &msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL rect[2]:RECT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		fnx ebx = GetWindowLong,hWnd,WND_DATA.hdc
		invoke DeleteObject,rv(SelectObject,ebx,rv(GetWindowLong,hWnd,WND_DATA.hBmp))
		invoke DeleteDC,ebx
	.elseif uMsg == WM_CREATE
		fnx GetClientRect,hWnd,&rect[16]
		fnx GetWindowRect,hWnd,&rect
		mov eax,rect.right
		mov edx,rect.bottom
		sub eax,rect.left
		sub edx,rect.top
		sub eax,rect[16].right
		sub edx,rect[16].bottom
		lea eax,[eax+32*16]
		lea edx,[edx+32*16]
		fn MoveWindow,hWnd,rect.left,rect.top,eax,edx,0
		fnx GetClientRect,hWnd,&rect
		
		fnx esi = GetDC,rv(GetDesktopWindow)
		fnx ebx = CreateCompatibleDC,esi
		fnx edi = CreateCompatibleBitmap,esi,rect.right,rect.bottom
		fn DeleteObject,rv(SelectObject,ebx,edi)
		fn ReleaseDC,rv(GetDesktopWindow),esi
		fn SetWindowLong,hWnd,WND_DATA.hBmp,edi
		fn SetWindowLong,hWnd,WND_DATA.hdc,ebx
		fn BitBlt,ebx,0,0,rect.right,rect.bottom,ebx,0,0,PATCOPY
		
		.data
			UCC wstr," some nice unicode  characters:\n"
			UCC     ,0fffch," ",260Eh," ",260Fh," ",2620h," ",2623h," ",262Dh," ",262Eh,"\n"
			dw 0
		.code
		fnx DrawTextW,ebx,&wstr,-1,&rect,0
		
	.elseif uMsg == WM_PAINT
		fnx BeginPaint,hWnd,&ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		fnx EndPaint,hWnd,&ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main
